!=====================================================================
! $BB.EYJ,I[7W;;%5%V%k!<%A%s(B
! 2001/12/08 $B1tD>J,I[%k!<%A%s40N;(B
! 2003/11/02 $B=$O@$+$i0\?"(B
!=====================================================================
module u_pack
  
  use prm, only : IMAX, JMAX, KMAX,   &
       &          dx
  use prmphys, only :     rho, grav, Npw, A_con
  use com_var, only : x, zk, zk_half


  implicit none

  private
  public get_U                  ! $B?eJ?B.EY$NF3=P(B
  public get_U_ana                  ! $B?eJ?B.EY$NF3=P(B
!  public get_w                  ! $B1tD>B.EY$NF3=P(B
  public get_F                  ! $B?eJ?B.EY%U%i%C%/%9$NF3=P(B
  public get_F_ana                  ! $B?eJ?B.EY%U%i%C%/%9$NF3=P(B
!  public get_sigma              ! $BJP:91~NO$NF3=P(B

contains
!=====================================================================
! $B?eJ?B.EYJ,I[(B($BBf7AB'$rMQ$$$?J}K!(B)
!=====================================================================
subroutine get_U(Hsfc1, Hbnd, Uvec1)
  implicit none

  real(8), INTENT(IN)  :: Hsfc1(1:IMAX, 1:JMAX)
  real(8), INTENT(IN)  :: Hbnd( 1:IMAX, 1:JMAX)
  real(8), INTENT(OUT) :: Uvec1(0:IMAX, 1:JMAX, 1:KMAX)

  real(8)              :: Uscle(0:IMAX, 1:JMAX)

  integer              :: i, j, k 

  ! x $BJ}8~$N6-3&$NCM$O$9$Y$F(B 0 
  Uvec1(0,    :, :) = 0 
  Uvec1(IMAX, :, :) = 0
 
  do j = 1, JMAX
     do i = 1,IMAX-1
        Uscle(i, j) = - (rho *grav)** Npw     &
        &             * ((Hsfc1(i+1, j) - Hsfc1(i, j))/dx)**Npw    &
        &             * ((Hsfc1(i+1, j) + Hsfc1(i, j))/2           &
        &                 - (Hbnd(i+1, j)+Hbnd(i, j))/2)**(Npw+1)  

     ! $B:G2<AX(B
     Uvec1(i, j, 1) = Uscle(i, j) * A_con * (zk_half(2) - zk_half(1))/2 &
          &       * (1 - zk(1))** Npw /2

     ! $B:G2<AX$+$i:G>eAX(B
     do k = 2, KMAX
        Uvec1(i, j, k) = Uvec1(i, j, k-1)                    &
             &  + Uscle(i, j)  * A_con * (zk(k) - zk(k-1))  &
             &  * ((1 - zk(k-1))**Npw + (1 -zk(k))**Npw)/2
     end do
     end do
  end do

end subroutine get_u

!=====================================================================
! $B?eJ?<ANL%U%i%C%/%9J,I[(B($BBf7AB'$rMQ$$$?J}K!(B)
!=====================================================================
subroutine get_F(Hsfc1, Hbnd, Uvec1, Ufl)

  implicit none

  real(8), INTENT(IN)  :: Hsfc1(1:IMAX, 1:JMAX)
  real(8), INTENT(IN)  :: Hbnd( 1:IMAX, 1:JMAX)
  real(8), INTENT(IN)  :: Uvec1(0:IMAX, 1:JMAX, 1:KMAX)
  real(8), INTENT(OUT) :: Ufl(0:IMAX, 1:JMAX)


  integer              :: i, j, k 

  ! x $BJ}8~$N6-3&$NCM$O(B 0 $B$K8GDj(B
  Ufl(0, :)    = 0
  ufl(IMAX, :) = 0

  do j = 1, JMAX
     do i = 1, IMAX-1

        ! $B:G2<AX$^$G(B
        Ufl(i, j)    = Uvec1(i, j, 1)                         & 
                &         * ((Hsfc1(i+1, j) + Hsfc1(i, j))/2.0D0     &
                &            - (Hbnd(i+1, j) + Hbnd(i, j))/2.0D0) &
                &       * (zk_half(2) - zk_half(1))/2
        ! 2 $BAXL\$+$i:G>eAX$^$G(B
        do k = 2, KMAX
           Ufl(i, j) =  Ufl(i, j)                          &
                &      + ((Hsfc1(i+1, j) + Hsfc1(i, j))/2.0D0    &
                &            - (Hbnd(i+1, j) + Hbnd(i, j))/2.0D0) &
                &       * (zk(k) - zk(k-1))                   &
                &       *(Uvec1(i, j, k) + Uvec1(i, j, k-1))/2.0D0

        end do
        ! $B:G>eAX$+$iI=LL$^$G(B
        ! $BI=LLB.EY$O:G>eAX$NB.EY$HF1$8$H$7$?(B
        Ufl(i, j) = Ufl(i, j)  &
             &      + ((Hsfc1(i+1, j) + Hsfc1(i, j))/2.0D0    &
             &            - (Hbnd(i+1, j) + Hbnd(i, j))/2.0D0) &
             &       * (zk_half(KMAX) - zk_half(KMAX-1))*Uvec1(i, j, KMAX)

        
     end do
  end do

end subroutine get_F
!=====================================================================
! $B?eJ?B.EYJ,I[(B($B2r@OE*$K5a$a$kJ}K!(B)
! $BB.EY$,29EY$K0MB8$9$k>l9g$O;H$($J$$(B
!=====================================================================
subroutine get_U_ana(Hsfc1, Hbnd, Uvec1)
 implicit none


  real(8), INTENT(IN)  :: Hsfc1(1:IMAX, 1:JMAX)
  real(8), INTENT(IN)  :: Hbnd( 1:IMAX, 1:JMAX)
  real(8), INTENT(OUT) :: Uvec1(0:IMAX, 1:JMAX, 1:KMAX)

  integer              :: i, j,k
  ! x $BJ}8~$N6-3&$NCM$O(B 0 $B$K8GDj(B
  Uvec1(0, :, :)    = 0.0D0
  Uvec1(IMAX, :, :) = 0.0D0

  

  do j = 1, JMAX
     do i =1, IMAX
        do k = 1, KMAX
           Uvec1(i, j, k) =  - 2.0D0 * (rho *grav)** Npw   &
        &             * ((Hsfc1(i+1, j) - Hsfc1(i, j))/dx)**Npw    &
        &             * ((Hsfc1(i+1, j) + Hsfc1(i, j))/2.0D0             &
        &                  - ((Hbnd(i+1, j) + Hbnd(i, j))/2.0D0))**(Npw +1.0D0) &
        &             *  A_con /(Npw + 1.0D0)                      &
        &             * (1 - (1 - zk(k))**(Npw+1.0D0))
        end do
     end do
  end do

end subroutine get_U_ana




!=====================================================================
! $B?eJ?<ANL%U%i%C%/%9J,I[(B($B2r@OE*$K5a$a$kJ}K!(B)
!    $B$?$@$7(B, $B29EY0MB8%Q%i%a!<%?$ODj?t$H$7$F7W;;(B
!=====================================================================
subroutine get_F_ana(Hsfc1, Hbnd, Ufl)

  implicit none

  real(8), INTENT(IN)  :: Hsfc1(1:IMAX, 1:JMAX)
  real(8), INTENT(IN)  :: Hbnd( 1:IMAX, 1:JMAX)
  real(8), INTENT(OUT) :: Ufl(0:IMAX, 1:JMAX)


  integer              :: i, j


  ! x $BJ}8~$N6-3&$NCM$O(B 0 $B$K8GDj(B
  Ufl(0, :)    = 0.0D0
  Ufl(IMAX, :) = 0.0D0

  do j = 1, JMAX
     do i = 1, IMAX-1



        Ufl(i, j) = - 2.0D0 * (rho *grav)** Npw     &
        &             * ((Hsfc1(i+1, j) - Hsfc1(i, j))/dx)**Npw    &
        &             * ((Hsfc1(i+1, j) + Hsfc1(i, j))/2           &
        &                 - (Hbnd(i+1, j)+Hbnd(i, j))/2)**(Npw+2.0D0)  &
        &             * A_con /(Npw + 2.0D0)

        
     end do
  end do


end subroutine get_F_ana

end module u_pack

